diff --git a/drivers/common/meson.build b/drivers/common/meson.build
index ba6325adf3..66e12143b2 100644
--- a/drivers/common/meson.build
+++ b/drivers/common/meson.build
@@ -6,4 +6,4 @@ if is_windows
 endif
 
 std_deps = ['eal']
-drivers = ['cpt', 'dpaax', 'iavf', 'mvep', 'octeontx', 'octeontx2', 'sfc_efx']
+drivers = ['cpt', 'dpaax', 'iavf', 'mvep', 'octeontx', 'octeontx2']
diff --git a/drivers/common/sfc_efx/meson.build b/drivers/common/sfc_efx/meson.build
index d9afcf3eeb..1ca9510733 100644
--- a/drivers/common/sfc_efx/meson.build
+++ b/drivers/common/sfc_efx/meson.build
@@ -5,6 +5,11 @@
 # This software was jointly developed between OKTET Labs (under contract
 # for Solarflare) and Solarflare Communications, Inc.
 
+if is_windows
+	build = false
+	reason = 'not supported on Windows'
+endif
+
 if (arch_subdir != 'x86' or not dpdk_conf.get('RTE_ARCH_64')) and (arch_subdir != 'arm' or not host_machine.cpu_family().startswith('aarch64'))
 	build = false
 	reason = 'only supported on x86_64 and aarch64'
@@ -32,6 +37,7 @@ endforeach
 subdir('base')
 objs = [base_objs]
 
+deps += ['bus_pci']
 sources = files(
 	'sfc_efx.c',
 	'sfc_efx_mcdi.c',
diff --git a/drivers/common/sfc_efx/sfc_efx.c b/drivers/common/sfc_efx/sfc_efx.c
index a3146db255..0b78933d9f 100644
--- a/drivers/common/sfc_efx/sfc_efx.c
+++ b/drivers/common/sfc_efx/sfc_efx.c
@@ -62,6 +62,62 @@ sfc_efx_dev_class_get(struct rte_devargs *devargs)
 	return dev_class;
 }
 
+static efx_rc_t
+sfc_efx_find_mem_bar(efsys_pci_config_t *configp, int bar_index,
+		     efsys_bar_t *barp)
+{
+	efsys_bar_t result;
+	struct rte_pci_device *dev;
+
+	memset(&result, 0, sizeof(result));
+
+	if (bar_index < 0 || bar_index >= PCI_MAX_RESOURCE)
+		return -EINVAL;
+
+	dev = configp->espc_dev;
+
+	result.esb_rid = bar_index;
+	result.esb_dev = dev;
+	result.esb_base = dev->mem_resource[bar_index].addr;
+
+	*barp = result;
+
+	return 0;
+}
+
+static efx_rc_t
+sfc_efx_pci_config_readd(efsys_pci_config_t *configp, uint32_t offset,
+			 efx_dword_t *edp)
+{
+	int rc;
+
+	rc = rte_pci_read_config(configp->espc_dev, edp->ed_u32, sizeof(*edp),
+				 offset);
+
+	return (rc < 0 || rc != sizeof(*edp)) ? EIO : 0;
+}
+
+int
+sfc_efx_family(struct rte_pci_device *pci_dev,
+	       efx_bar_region_t *mem_ebrp, efx_family_t *family)
+{
+	static const efx_pci_ops_t ops = {
+		.epo_config_readd = sfc_efx_pci_config_readd,
+		.epo_find_mem_bar = sfc_efx_find_mem_bar,
+	};
+
+	efsys_pci_config_t espcp;
+	int rc;
+
+	espcp.espc_dev = pci_dev;
+
+	rc = efx_family_probe_bar(pci_dev->id.vendor_id,
+				  pci_dev->id.device_id,
+				  &espcp, &ops, family, mem_ebrp);
+
+	return rc;
+}
+
 RTE_INIT(sfc_efx_register_logtype)
 {
 	int ret;
diff --git a/drivers/common/sfc_efx/sfc_efx.h b/drivers/common/sfc_efx/sfc_efx.h
index bbccd3e9e8..71288b7299 100644
--- a/drivers/common/sfc_efx/sfc_efx.h
+++ b/drivers/common/sfc_efx/sfc_efx.h
@@ -10,6 +10,11 @@
 #ifndef _SFC_EFX_H_
 #define _SFC_EFX_H_
 
+#include <rte_bus_pci.h>
+
+#include "efx.h"
+#include "efsys.h"
+
 #ifdef __cplusplus
 extern "C" {
 #endif
@@ -27,6 +32,11 @@ enum sfc_efx_dev_class {
 __rte_internal
 enum sfc_efx_dev_class sfc_efx_dev_class_get(struct rte_devargs *devargs);
 
+__rte_internal
+int sfc_efx_family(struct rte_pci_device *pci_dev,
+		   efx_bar_region_t *mem_ebrp,
+		   efx_family_t *family);
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/drivers/common/sfc_efx/version.map b/drivers/common/sfc_efx/version.map
index a3345d34f7..c3414b760b 100644
--- a/drivers/common/sfc_efx/version.map
+++ b/drivers/common/sfc_efx/version.map
@@ -222,6 +222,7 @@ INTERNAL {
 	efx_txq_size;
 
 	sfc_efx_dev_class_get;
+	sfc_efx_family;
 
 	sfc_efx_mcdi_init;
 	sfc_efx_mcdi_fini;
diff --git a/drivers/meson.build b/drivers/meson.build
index fdf76120ac..9c8eded697 100644
--- a/drivers/meson.build
+++ b/drivers/meson.build
@@ -7,6 +7,7 @@ subdirs = [
 	'bus',
 	'common/mlx5', # depends on bus.
 	'common/qat', # depends on bus.
+	'common/sfc_efx', # depends on bus.
 	'mempool', # depends on common and bus.
 	'net',     # depends on common, bus, mempool
 	'raw',     # depends on common, bus and net.
diff --git a/drivers/net/sfc/sfc.c b/drivers/net/sfc/sfc.c
index 3135068c39..3477c7530b 100644
--- a/drivers/net/sfc/sfc.c
+++ b/drivers/net/sfc/sfc.c
@@ -631,29 +631,6 @@ sfc_close(struct sfc_adapter *sa)
 	sfc_log_init(sa, "done");
 }
 
-static efx_rc_t
-sfc_find_mem_bar(efsys_pci_config_t *configp, int bar_index,
-		 efsys_bar_t *barp)
-{
-	efsys_bar_t result;
-	struct rte_pci_device *dev;
-
-	memset(&result, 0, sizeof(result));
-
-	if (bar_index < 0 || bar_index >= PCI_MAX_RESOURCE)
-		return EINVAL;
-
-	dev = configp->espc_dev;
-
-	result.esb_rid = bar_index;
-	result.esb_dev = dev;
-	result.esb_base = dev->mem_resource[bar_index].addr;
-
-	*barp = result;
-
-	return 0;
-}
-
 static int
 sfc_mem_bar_init(struct sfc_adapter *sa, const efx_bar_region_t *mem_ebrp)
 {
@@ -1095,43 +1072,12 @@ sfc_nic_probe(struct sfc_adapter *sa)
 	return 0;
 }
 
-static efx_rc_t
-sfc_pci_config_readd(efsys_pci_config_t *configp, uint32_t offset,
-		     efx_dword_t *edp)
-{
-	int rc;
-
-	rc = rte_pci_read_config(configp->espc_dev, edp->ed_u32, sizeof(*edp),
-				 offset);
-
-	return (rc < 0 || rc != sizeof(*edp)) ? EIO : 0;
-}
-
-static int
-sfc_family(struct sfc_adapter *sa, efx_bar_region_t *mem_ebrp)
-{
-	struct rte_eth_dev *eth_dev = sa->eth_dev;
-	struct rte_pci_device *pci_dev = RTE_ETH_DEV_TO_PCI(eth_dev);
-	efsys_pci_config_t espcp;
-	static const efx_pci_ops_t ops = {
-		.epo_config_readd = sfc_pci_config_readd,
-		.epo_find_mem_bar = sfc_find_mem_bar,
-	};
-	int rc;
-
-	espcp.espc_dev = pci_dev;
-
-	rc = efx_family_probe_bar(pci_dev->id.vendor_id,
-				  pci_dev->id.device_id,
-				  &espcp, &ops, &sa->family, mem_ebrp);
-
-	return rc;
-}
-
 int
 sfc_probe(struct sfc_adapter *sa)
 {
 	efx_bar_region_t mem_ebrp;
+	struct rte_eth_dev *eth_dev = sa->eth_dev;
+	struct rte_pci_device *pci_dev = RTE_ETH_DEV_TO_PCI(eth_dev);
 	efx_nic_t *enp;
 	int rc;
 
@@ -1143,7 +1089,8 @@ sfc_probe(struct sfc_adapter *sa)
 	rte_atomic32_init(&sa->restart_required);
 
 	sfc_log_init(sa, "get family");
-	rc = sfc_family(sa, &mem_ebrp);
+	rc = sfc_efx_family(pci_dev, &mem_ebrp, &sa->family);
+
 	if (rc != 0)
 		goto fail_family;
 	sfc_log_init(sa,